<template>
  <div class="main-page">
    <div class="nav">
      <ul>
        <li class="title">SORT VISUALIZER</li>
      </ul>
    </div>
    <div class="content">
      <div class="panel input-panel">
        <InputPanel @new-array="newArray" />
      </div>
      <div class="panel visualizer-panel">
        <VisualizerPanel
          @selection-sort="selectionSort"
          @bubble-sort="bubbleSort"
          @insertion-sort="insertionSort"
          :inputArray="inputArray"
          :outputArray="outputArray"
        />
      </div>
    </div>
  </div>
</template>

<script>
import InputPanel from "./components/input/InputPanel";
import VisualizerPanel from "./components/visualizer/VisualizerPanel";

export default {
  name: "App",
  components: {
    InputPanel,
    VisualizerPanel,
  },
  data() {
    return {
      inputArray: [],
      outputArray: [],
      arrayColor: "#F0F8FF",
      firstIterationColor: "#40b2e1",
      secondIterationColor: "#ecce58",
      swapColor: "#a3e9d4",
    };
  },
  methods: {
    // TODO custom array not generating properly with values >= 10
    newArray(array) {
      this.inputArray = array;
      this.outputArray = this.formatArray(this.inputArray, "#F0F8FF");

      /*
      Add a call to the method you want to test.
      eg:
      this.bubbleSort();
      */
    },
    formatArray(numbersArray) {
      /*
      Use this method to format from the inputArray to the outputArray.
      IMPORTANT!!! after using this method, you have to iterate over the outputArray to set the color of each position.
      */
      const maxValue = numbersArray.reduce(
        (max, val) => (val > max ? val : max),
        numbersArray[0]
      );

      const size = numbersArray.length;
      let value;

      const formatedArray = numbersArray.map((element) => {
        const percentage = (100 * element) / maxValue;
        const leftover = 100 - percentage;
        // If numbersArray > 10 the visualizer will not show the number value
        value = size >= 10 ? "" : element;

        return {
          value: value,
          color: this.arrayColor,
          percentage: percentage + "%",
          leftover: leftover + "%",
          // TODO If numbersArray < 10 add a property height so it is not to thick with lower values
        };
      });

      return formatedArray;
    },

    setColor(index, color) {
      this.outputArray[index].color = color;
    },

    sleep() {
      // TODO if input array length is > x the ms should be higher
      const ms = 1000;
      return new Promise((resolve) => setTimeout(resolve, ms));
    },
    async selectionSort() {
      const sortingArray = [...this.inputArray];
      const arrayCount = sortingArray.length;
      let i, j, indexOfMin;

      // One by one move boundary of unsorted subarray
      for (i = 0; i < arrayCount - 1; i++) {
        this.setColor(i, this.firstIterationColor);
        await this.sleep();
        // Find the minimum element in usorted array
        indexOfMin = i;
        for (j = i + 1; j < arrayCount; j++) {
          this.setColor(j, this.secondIterationColor);
          await this.sleep();
          if (sortingArray[j] < sortingArray[indexOfMin]) {
            if (indexOfMin !== i) {
              this.setColor(indexOfMin, this.arrayColor);
            }
            indexOfMin = j;
            this.setColor(indexOfMin, this.swapColor);
            await this.sleep();
          } else {
            this.setColor(j, this.arrayColor);
          }
        }

        if (indexOfMin !== i) {
          this.setColor(i, this.swapColor);
          await this.sleep();

          // Swap the found minimum element with the first element
          this.selectionSwap(sortingArray, indexOfMin, i);
          this.outputArray = this.formatArray(sortingArray, this.arrayColor);

          this.setColor(i, this.swapColor);
          this.setColor(indexOfMin, this.swapColor);
          await this.sleep();
          this.setColor(i, this.arrayColor);
          this.setColor(indexOfMin, this.arrayColor);
        } else {
          this.setColor(i, this.arrayColor);
        }
      }
    },

    selectionSwap(swapingArray, firstPosition, secondPosition) {
      const temp = swapingArray[firstPosition];
      swapingArray[firstPosition] = swapingArray[secondPosition];
      swapingArray[secondPosition] = temp;
    },
    async bubbleSort() {
      const sortingArray = [...this.inputArray];
      const arrayCount = sortingArray.length;

      let checked;
      debugger;
      do {
        checked = false;
        for (let i = 0; i < arrayCount - 1; i++) {
          this.setColor(i, this.firstIterationColor);
          this.setColor(i + 1, this.secondIterationColor);
          await this.sleep();
          if (sortingArray[i] > sortingArray[i + 1]) {
            this.setColor(i + 1, this.swapColor);
            this.setColor(i, this.swapColor);
            await this.sleep();
            this.selectionSwap(sortingArray, i, i + 1);
            checked = true;
            this.outputArray = this.formatArray(sortingArray);
            this.setColor(i + 1, this.firstIterationColor);
            this.setColor(i, this.secondIterationColor);
            await this.sleep();
            this.outputArray = this.formatArray(sortingArray);
          } else {
            this.outputArray = this.formatArray(sortingArray);
          }
        }
      } while (checked);
    },
    async insertionSort() {
      const sortingArray = [...this.inputArray];
      const arrayCount = sortingArray.length;
      for (let i = 1; i < arrayCount; i++) {
        // Choosing the first element in our unsorted subarray
        let current = sortingArray[i];
        // The last element of our sorted subarray
        let j = i - 1;
        this.setColorInsertioSubarray(i, this.swapColor);
        await this.sleep();
        while (j > -1 && current < sortingArray[j]) {
          this.selectionSwap(sortingArray, j + 1, j);
          this.outputArray = this.formatArray(sortingArray);
          this.setColorInsertioSubarray(i, this.swapColor);
          this.setColor(j, this.firstIterationColor);
          this.setColor(j+1,this.swapColor);
          await this.sleep();
          j--;
        }
        sortingArray[j + 1] = current;
        this.outputArray = this.formatArray(sortingArray);
        
      }
    },

    setColorInsertioSubarray(i, color) {
      for (let index = 0; index <= i; index++) {
        this.setColor(index, color);
      }
    },
  },
};
</script>

<style>
.palette {
  color: #121a21;
  color: #000000;
  color: #ff4c41;
  color: #c4d364;
  color: #ecce58;
  color: #40b2e1;
  color: #f5878b;
  color: #a3e9d4;
  color: #ffffff;
}
.main-page {
  height: 100vh;
  width: 100vw;
  background-color: blue;
}
.nav {
  height: 60px;
  background-color: #000;
  color: #fff;
  padding-top: 0.6em;
}
.nav li {
  font-weight: bold;
  font-size: 1.5em;
  color: whitesmoke;
}
.nav ul {
  list-style: none;
  text-align: center;
}
.content {
  height: calc(100vh - 60px);
  background-color: #121a21;
}
.input-panel {
  height: 170px;
}
.visualizer-panel {
  display: flex;
  height: calc(100% - 170px);
  position: relative;
  justify-content: space-between;
}
@import url("https://fonts.googleapis.com/css2?family=Roboto+Slab&display=swap");
@import url("https://fonts.googleapis.com/css?family=Roboto:300,300italic,700,700italic");

@import url("https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.1/normalize.css");
@import url("https://cdnjs.cloudflare.com/ajax/libs/milligram/1.4.1/milligram.css");
</style>
